#include "ServiceManager.hpp"

// C++ system level
// #include <cstring>     // memset, strncmp
// #include <cstdlib>     // TODO: is this for memcpy?
// #include <functional>

// ESP32 specific
#include "esp_log.h"

// project specific
#include <Types.hpp>
// #include "SiliconTorch/NVSExplorer.hpp"

// qthing stuff
// #include <qthing>


static const char* TAG = "ServiceManager";


namespace SiliconTorch {

  namespace ServiceManager {


    void registerSiliconTorchServices(ServiceManager* mgr);


    ServiceManager::ServiceManager() {

      registerSiliconTorchServices(this);

      // TODO: implement!

    }


    void ServiceManager::registerService(Service* s) {
      s->init();
      s->postInit();

      services[s->getName()] = s;

      ESP_LOGI(TAG, "Registered service[ %s ]", s->getName().c_str());

    }



  }
}
